/*
 * Copyright (c) 2018 - present.  Boling Consulting Solutions (bcsw.net)
 * Copyright 2020-present Open Networking Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/*
 * NOTE: This file was generated, manual edits will be overwritten!
 *
 * Generated by 'goCodeGenerator.py':
 *              https://github.com/cboling/OMCI-parser/README.md
 */

package generated

import "github.com/deckarep/golang-set"

// EfmBondingPortPerformanceMonitoringHistoryDataClassID is the 16-bit ID for the OMCI
// Managed entity EFM bonding port performance monitoring history data
const EfmBondingPortPerformanceMonitoringHistoryDataClassID = ClassID(423) // 0x01a7

var efmbondingportperformancemonitoringhistorydataBME *ManagedEntityDefinition

// EfmBondingPortPerformanceMonitoringHistoryData (Class ID: #423 / 0x01a7)
//	This ME collects PM data as seen at the xTU-C. Instances of this ME are created and deleted by
//	the OLT.
//
//	Relationships
//		An instance of this ME is associated with an xDSL UNI.
//
//	Attributes
//		Managed Entity Id
//			This attribute uniquely identifies each instance of this ME. The two MSBs of the first byte are
//			the bearer channel ID. Excluding the first 2-bits of the first byte, the remaining part of the
//			ME ID is identical to that of this ME's parent PPTP xDSL UNI part 1. (R, setbycreate)
//			(mandatory) (2-bytes)
//
//		Interval End Time
//			This attribute identifies the most recently finished 15-min interval. (R) (mandatory) (1-byte)
//
//		Threshold Data 1_2 Id
//			Threshold data 1/2 ID: This attribute points to an instance of the threshold data 1 and 2 MEs
//			that contain PM threshold values. (R,-W, setbycreate) (mandatory) (2-bytes)
//
//		Rx Frames
//			Number of Ethernet frames received over this port. (R) (mandatory) (4-bytes)
//
//		Tx Frames
//			Number of Ethernet frames transmitted over this port. (R) (mandatory) (4-bytes)
//
//		Rx Bytes
//			Number of bytes contained in the Ethernet frames received over this port. (R) (mandatory)
//			(4-bytes)
//
//		Tx Bytes
//			Number of bytes contained in the Ethernet frames transmitted over this port. (R) (mandatory)
//			(4-bytes)
//
//		Tx Discarded Frames
//			Number of Ethernet frames discarded by the port transmit function. (R) (mandatory) (4-bytes)
//
//		Tx Discarded Bytes
//			Number of bytes contained in the Ethernet frames discarded by the port transmit function. (R)
//			(mandatory) (4-bytes)
//
type EfmBondingPortPerformanceMonitoringHistoryData struct {
	ManagedEntityDefinition
	Attributes AttributeValueMap
}

// Attribute name constants

const EfmBondingPortPerformanceMonitoringHistoryData_IntervalEndTime = "IntervalEndTime"
const EfmBondingPortPerformanceMonitoringHistoryData_ThresholdData12Id = "ThresholdData12Id"
const EfmBondingPortPerformanceMonitoringHistoryData_RxFrames = "RxFrames"
const EfmBondingPortPerformanceMonitoringHistoryData_TxFrames = "TxFrames"
const EfmBondingPortPerformanceMonitoringHistoryData_RxBytes = "RxBytes"
const EfmBondingPortPerformanceMonitoringHistoryData_TxBytes = "TxBytes"
const EfmBondingPortPerformanceMonitoringHistoryData_TxDiscardedFrames = "TxDiscardedFrames"
const EfmBondingPortPerformanceMonitoringHistoryData_TxDiscardedBytes = "TxDiscardedBytes"

func init() {
	efmbondingportperformancemonitoringhistorydataBME = &ManagedEntityDefinition{
		Name:    "EfmBondingPortPerformanceMonitoringHistoryData",
		ClassID: EfmBondingPortPerformanceMonitoringHistoryDataClassID,
		MessageTypes: mapset.NewSetWith(
			Create,
			Delete,
			Get,
			Set,
			GetCurrentData,
		),
		AllowedAttributeMask: 0xff00,
		AttributeDefinitions: AttributeDefinitionMap{
			0: Uint16Field(ManagedEntityID, PointerAttributeType, 0x0000, 0, mapset.NewSetWith(Read, SetByCreate), false, false, false, 0),
			1: ByteField(EfmBondingPortPerformanceMonitoringHistoryData_IntervalEndTime, UnsignedIntegerAttributeType, 0x8000, 0, mapset.NewSetWith(Read), false, false, false, 1),
			2: Uint16Field(EfmBondingPortPerformanceMonitoringHistoryData_ThresholdData12Id, UnsignedIntegerAttributeType, 0x4000, 0, mapset.NewSetWith(Read, SetByCreate, Write), false, false, false, 2),
			3: Uint32Field(EfmBondingPortPerformanceMonitoringHistoryData_RxFrames, CounterAttributeType, 0x2000, 0, mapset.NewSetWith(Read), false, false, false, 3),
			4: Uint32Field(EfmBondingPortPerformanceMonitoringHistoryData_TxFrames, CounterAttributeType, 0x1000, 0, mapset.NewSetWith(Read), false, false, false, 4),
			5: Uint32Field(EfmBondingPortPerformanceMonitoringHistoryData_RxBytes, CounterAttributeType, 0x0800, 0, mapset.NewSetWith(Read), false, false, false, 5),
			6: Uint32Field(EfmBondingPortPerformanceMonitoringHistoryData_TxBytes, CounterAttributeType, 0x0400, 0, mapset.NewSetWith(Read), false, false, false, 6),
			7: Uint32Field(EfmBondingPortPerformanceMonitoringHistoryData_TxDiscardedFrames, CounterAttributeType, 0x0200, 0, mapset.NewSetWith(Read), false, false, false, 7),
			8: Uint32Field(EfmBondingPortPerformanceMonitoringHistoryData_TxDiscardedBytes, CounterAttributeType, 0x0100, 0, mapset.NewSetWith(Read), false, false, false, 8),
		},
		Access:  CreatedByOlt,
		Support: UnknownSupport,
	}
}

// NewEfmBondingPortPerformanceMonitoringHistoryData (class ID 423) creates the basic
// Managed Entity definition that is used to validate an ME of this type that
// is received from or transmitted to the OMCC.
func NewEfmBondingPortPerformanceMonitoringHistoryData(params ...ParamData) (*ManagedEntity, OmciErrors) {
	return NewManagedEntity(*efmbondingportperformancemonitoringhistorydataBME, params...)
}
